%{?scl:%scl_package nekohtml}
%{!?scl:%global pkg_name %{name}}
%{!?maven_scl:%global maven_scl_prefix %{nil}}

# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

Name:           %{?scl_prefix}nekohtml
Version:        1.9.20
Release:        3%{?dist}
Epoch:          0
Summary:        HTML scanner and tag balancer
License:        ASL 2.0
URL:            http://nekohtml.sourceforge.net/
Source0:        http://downloads.sourceforge.net/%{pkg_name}/%{pkg_name}-%{version}.tar.gz
Source2:        nekohtml-component-info.xml
Source3:        http://central.maven.org/maven2/net/sourceforge/%{pkg_name}/%{pkg_name}/%{version}/%{pkg_name}-%{version}.pom
Patch0:         %{pkg_name}-crosslink.patch
Patch1:         %{pkg_name}-jars.patch
# Add proper attributes to MANIFEST.MF file so bundle can be used by other OSGI bundles.
Patch2:		%{pkg_name}-osgi.patch

Requires:       bcel
Requires:       xerces-j2 >= 0:2.7.1
Requires:       xml-commons-apis
BuildRequires:  %{maven_scl_prefix}maven-local
BuildRequires:  ant
BuildRequires:  ant-junit
BuildRequires:  java-javadoc
BuildRequires:  bcel
BuildRequires:  bcel-javadoc
BuildRequires:  xerces-j2 >= 0:2.7.1
BuildRequires:  xerces-j2-javadoc-impl
BuildRequires:  xerces-j2-javadoc-xni
BuildRequires:  xml-commons-apis

%{?scl:Requires: %scl_runtime}

Requires:       java

BuildArch:      noarch

%description
NekoHTML is a simple HTML scanner and tag balancer that enables
application programmers to parse HTML documents and access the
information using standard XML interfaces. The parser can scan HTML
files and "fix up" many common mistakes that human (and computer)
authors make in writing HTML documents.  NekoHTML adds missing parent
elements; automatically closes elements with optional end tags; and
can handle mismatched inline element tags.
NekoHTML is written using the Xerces Native Interface (XNI) that is
the foundation of the Xerces2 implementation. This enables you to use
the NekoHTML parser with existing XNI tools without modification or
rewriting code.

%package javadoc
Summary:        Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

%package demo
Summary:        Demo for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description demo
Demonstrations and samples for %{name}.

%prep
%setup -q -n %{pkg_name}-%{version}
%patch0 -p1
%patch1 -p1
%patch2
find . -name "*.jar" | xargs -t %{__rm}
%{__perl} -pi -e 's/\r$//g' *.txt doc/*.html
%{__rm} -r doc/javadoc

scl enable %{scl} - <<"EOF"

%mvn_alias net.sourceforge.%{pkg_name}:%{pkg_name} %{pkg_name}:%{pkg_name}
%mvn_package net.sourceforge.%{pkg_name}:%{pkg_name}-samples demo
%mvn_file ':{*}' @1

EOF

%build

export JAVA_HOME=%{java_home}

export CLASSPATH=$(build-classpath bcel xerces-j2)
%{ant} \
    -Dbuild.sysclasspath=first \
    -Dlib.dir=%{_root_datadir}/java \
    -Djar.file=%{pkg_name}.jar \
    -Djar.xni.file=%{pkg_name}-xni.jar \
    -Djar.samples.file=%{pkg_name}-samples.jar \
    -Dbcel.javadoc=%{_root_datadir}/javadoc/bcel \
    -Dj2se.javadoc=%{_root_datadir}/javadoc/java \
    -Dxni.javadoc=%{_root_datadir}/javadoc/xerces-j2-xni \
    -Dxerces.javadoc=%{_root_datadir}/javadoc/xerces-j2-impl \
    clean jar jar-xni doc 
# test - disabled because it makes the build failing

scl enable %{scl} - <<"EOF"
%mvn_artifact %{SOURCE3} %{pkg_name}.jar
%mvn_artifact net.sourceforge.%{pkg_name}:%{pkg_name}-xni:%{version} %{pkg_name}-xni.jar
%mvn_artifact net.sourceforge.%{pkg_name}:%{pkg_name}-samples:%{version} %{pkg_name}-samples.jar
EOF

%install
scl enable %{scl} - <<"EOF"

%mvn_install
EOF

install -dm755 ${RPM_BUILD_ROOT}%{_javadocdir}/nekohtml
cp -pr build/doc/javadoc/*.html  build/doc/javadoc/package-list build/doc/javadoc/resources build/doc/javadoc/stylesheet.css ${RPM_BUILD_ROOT}%{_javadocdir}/nekohtml

# Scripts
%jpackage_script org.cyberneko.html.filters.Writer "" "" "nekohtml:xerces-j2" nekohtml-filter true

%files -f .mfiles
%doc LICENSE.txt README.txt doc/*.html
%{_bindir}/%{pkg_name}-filter

%files javadoc
%dir %{_javadocdir}/nekohtml
%{_javadocdir}/nekohtml

%files demo -f .mfiles-demo

%changelog
* Wed May 28 2014 Jeff Johnston <jjohnstn@redhat.com> - 0:1.9.20-3
- Add requires of org.apache.xerces to MANIFEST.MF

* Fri May 23 2014 Roland Grunberg <rgrunber@redhat.com> - 0:1.9.20-2
- Change R: on java-headless to java.

* Fri May 16 2014 Jeff Johnston <jjohnstn@redhat.com> - 0:1.9.20-1
- Initial import of 1.9.20 package from F21 rawhide, scl-ized.
